//
//  audioVewController.m
//  MoMuBasics
//
//  Created by Jieun Oh on 6/10/10.
//  Copyright 2010 Stanford University. All rights reserved.
//

#import "audioVewController.h"
#import "mo_audio.h"
#import <math.h>

#define SRATE 44100
#define FRAMESIZE 128
#define NUMCHANNELS 2

bool g_play = false;
double g_fc = 440.0; 
// double amplitude = 0.0;

// Implement audio callback here
void audioCallback( Float32 * buffer, UInt32 framesize, void* userData)
{
	// NSLog(@"inside audioCB");
	
	if (g_play) {
		static float phase = g_fc/SRATE;
		// amplitude = amplitude+(1-amplitude)*0.001; // to avoid clicks
	
		for (int i=0; i<framesize; i++)	{
			buffer[2*i] = buffer[2*i+1] = sin(2.0*M_PI*phase);    // amplitude*sin(2.0*M_PI*phase);
			phase += g_fc/(SRATE*1.0);
		
			if (phase > 1.0f) 
				phase -= 1.0f;
		}
	}
	else {
		for (int i=0; i<framesize; i++)	{
			buffer[2*i] = buffer[2*i+1] = 0.0;
		}
	}

}

@implementation audioVewController

@synthesize mySwitch;

-(IBAction)toggleSwitch:(UISwitch *)sender
{
	NSLog(@"toggled switch");
	g_play = sender.isOn;
}


/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil])) {
        // Custom initialization
    }
    return self;
}
*/


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
		
    [super viewDidLoad];
	
	// init audio
	NSLog(@"Initializing Audio");
	
	// init the audio layer
	bool result = MoAudio::init(SRATE, FRAMESIZE, NUMCHANNELS);
	
	if (!result)
	{
		NSLog(@"cannot initialize real-time audio!");
		return;
	}
	
	// start the audio layer, registering a callback method
	result = MoAudio::start( audioCallback, NULL);
	if (!result)
	{
		NSLog(@"cannot start real-time audio!");
		return;
	}	
}


/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
}


@end
